/**
 * @file artis/kernel/Internals.hpp
 * @author See the AUTHORS file
 */

/*
 * Copyright (C) 2012-2016 ULCO http://www.univ-littoral.fr
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __ARTIS_KERNEL_INTERNALS_HPP
#define __ARTIS_KERNEL_INTERNALS_HPP

#include <artis/kernel/State.hpp>
#include <artis/kernel/Value.hpp>

#include <vector>

namespace artis { namespace kernel {

template < typename T, typename U >
class Internals
{
public:
    Internals()
    { }

    virtual ~Internals()
    { }

    const Any& get(unsigned int index) const
    { return internals.at(index); }

    template < typename V >
    void I(std::initializer_list < std::pair < unsigned int,
           V T::* > > list)
    {
        for (typename std::initializer_list < std::pair < unsigned int,
                 V T::* > >::iterator it = list.begin(); it != list.end();
             ++it) {
            if (internals.size() <= it->first) {
                internals.resize(it->first + 1);
            }
            internals[it->first] = it->second;
        }
    }

    template < typename V >
    void internal(unsigned int index, V T::* var)
    {
        if (internals.size() <= index) {
            internals.resize(index + 1);
        }
        internals[index] = Any(var);
    }

    virtual void restore(const State < U >& /* state */)
    {
        // unsigned int index = 0;

        // for (typename std::vector < Any >::iterator it =
        //          internals.begin(); it != internals.end(); ++it) {
        //     state.get_internal(index, *it);
        //     ++index;
        // }
        // index = 0;
        // for (typename std::vector < int T::* >::iterator it =
        //          internalsI.begin(); it != internalsI.end(); ++it) {
        //     state.get_internal(index, *it);
        //     ++index;
        // }
        // index = 0;
        // for (typename std::vector < double T::* >::iterator it =
        //          internalsD.begin(); it != internalsD.end(); ++it) {
        //     state.get_internal(index, *it);
        //     ++index;
        // }
    }

    virtual void save(State < U >& /* state */) const
    {
        // unsigned int index = 0;

        // for (typename std::vector < bool T::* >::const_iterator it =
        //          internalsB.begin(); it != internalsB.end(); ++it) {
        //     state.add_internal(index, *it);
        //     ++index;
        // }
        // index = 0;
        // for (typename std::vector < int T::* >::const_iterator it =
        //          internalsI.begin(); it != internalsI.end(); ++it) {
        //     state.add_internal(index, *it);
        //     ++index;
        // }
        // index = 0;
        // for (typename std::vector < double T::* >::const_iterator it =
        //          internalsD.begin(); it != internalsD.end(); ++it) {
        //     state.add_internal(index, *it);
        //     ++index;
        // }
    }

private:
    std::vector < Any > internals;
};

} } // namespace artis kernel

#endif
